## olsrd 0.6.3

=== Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

# Please also write a new version to:
# gui/win32/Main/Frontend.rc (line 71, around "CAPTION [...]")
# gui/win32/Inst/installer.nsi (line 57, around "MessageBox MB_YESNO [...]")
VERS =		0.6.3

TOPDIR = .
include Makefile.inc

# pass generated variables to save time
MAKECMD = $(MAKE) OS="$(OS)" WARNINGS="$(WARNINGS)"

LIBS +=		$(OS_LIB_DYNLOAD)

ifeq ($(OS), win32)
LDFLAGS +=	-Wl,--out-implib=libolsrd.a
LDFLAGS +=	-Wl,--export-all-symbols
endif

SWITCHDIR =	src/olsr_switch
CFGDIR =	src/cfgparser
include $(CFGDIR)/local.mk
TAG_SRCS =	$(SRCS) $(HDRS) $(wildcard $(CFGDIR)/*.[ch] $(SWITCHDIR)/*.[ch])

.PHONY: default_target switch
default_target: $(EXENAME)

$(EXENAME):	$(OBJS) src/builddata.o
		@echo "[LD] $@"
		@$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

cfgparser:	$(CFGDEPS) src/builddata.o
		$(MAKE) -C $(CFGDIR)

switch:		
	@$(MAKECMD) -C $(SWITCHDIR)

# generate it always
.PHONY: src/builddata.c
src/builddata.c:
	@$(RM) "$@"
	@echo "#include \"defs.h\"" >> "$@" 
	@echo "const char olsrd_version[] = \"olsr.org -  $(VERS)-git_`git log -1 --pretty=%h`-hash_`./make/hash_source.sh`\";"  >> "$@"
	@date +"const char build_date[] = \"%Y-%m-%d %H:%M:%S\";" >> "$@" 
	@echo "const char build_host[] = \"$(shell hostname)\";" >> "$@" 


.PHONY: help libs clean_libs libs_clean clean distclean uberclean install_libs uninstall_libs libs_install libs_uninstall install_bin uninstall_bin install_olsrd uninstall_olsrd install uninstall build_all install_all uninstall_all clean_all 

clean:
	-rm -f $(OBJS) $(SRCS:%.c=%.d) $(EXENAME) $(EXENAME).exe src/builddata.c $(TMPFILES)
	-rm -f libolsrd.a
	-rm -f olsr_switch.exe
	-rm -f gui/win32/Main/olsrd_cfgparser.lib
	-rm -f olsr-setup.exe
	-rm -fr gui/win32/Main/Release
	-rm -fr gui/win32/Shim/Release

clean_gui:
	$(MAKE) -C gui/linux-gtk clean

distclean: uberclean
uberclean:	clean clean_libs clean_gui
	-rm -f $(TAGFILE)
#	BSD-xargs has no "--no-run-if-empty" aka "-r"
	find . \( -name '*.[od]' -o -name '*~' \) -not -path "*/.hg*" -type f -print0 | xargs -0 rm -f
	@$(MAKECMD) -C $(SWITCHDIR) clean
	@$(MAKECMD) -C $(CFGDIR) clean

install: install_olsrd

uninstall: uninstall_olsrd

install_bin:
		mkdir -p $(SBINDIR)
		install -m 755 $(EXENAME) $(SBINDIR)
		$(STRIP) $(SBINDIR)/$(EXENAME)

uninstall_bin:
		rm -f $(SBINDIR)/$(EXENAME)
		rmdir -p --ignore-fail-on-non-empty $(SBINDIR)

install_olsrd:	install_bin
		@echo ========= C O N F I G U R A T I O N - F I L E ============
		@echo $(EXENAME) uses the configfile $(CFGFILE)
		@echo a default configfile. A sample RFC-compliance aimed
		@echo configfile can be found in olsrd.conf.default.rfc.
		@echo However none of the larger OLSRD using networks use that
		@echo so install a configfile with activated link quality exstensions
		@echo per default.
		@echo can be found at files/olsrd.conf.default.lq
		@echo ==========================================================
		mkdir -p $(ETCDIR)
		-cp -i files/olsrd.conf.default.lq $(CFGFILE)
		@echo -------------------------------------------
		@echo Edit $(CFGFILE) before running olsrd!!
		@echo -------------------------------------------
		@echo Installing manpages $(EXENAME)\(8\) and $(CFGNAME)\(5\)
ifneq ($(MANDIR),)
		mkdir -p $(MANDIR)/man8/
		cp files/olsrd.8.gz $(MANDIR)/man8/$(EXENAME).8.gz
		mkdir -p $(MANDIR)/man5/
		cp files/olsrd.conf.5.gz $(MANDIR)/man5/$(CFGNAME).5.gz
endif

uninstall_olsrd:	uninstall_bin
ifneq ($(MANDIR),)
		rm -f $(MANDIR)/man5/$(CFGNAME).5.gz
		rmdir -p --ignore-fail-on-non-empty $(MANDIR)/man5/
		rm -f $(MANDIR)/man8/$(EXENAME).8.gz
		rmdir -p --ignore-fail-on-non-empty $(MANDIR)/man8/
endif
		rm -f $(CFGFILE)
		rmdir -p --ignore-fail-on-non-empty $(ETCDIR)

tags:
		$(TAGCMD) -o $(TAGFILE) $(TAG_SRCS)

rpm:
		@$(RM) olsrd-current.tar.bz2
		@echo "Creating olsrd-current.tar.bz2 ..."
		@./list-excludes.sh | tar  --exclude-from=- --exclude="olsrd-current.tar.bz2" -C .. -cjf olsrd-current.tar.bz2 olsrd-current
		@echo "Building RPMs..."
		@rpmbuild -ta olsrd-current.tar.bz2
#
# PLUGINS
#

# This is quite ugly but at least it works
ifeq ($(OS),linux)
SUBDIRS = arprefresh bmf dot_draw dyn_gw dyn_gw_plain httpinfo jsoninfo mdns mini nameservice p2pd pgraph quagga secure tas txtinfo watchdog
else
ifeq ($(OS),win32)
SUBDIRS := dot_draw httpinfo jsoninfo mini pgraph secure txtinfo
else
ifeq ($(OS),android)
SUBDIRS := arprefresh bmf dot_draw dyn_gw_plain httpinfo jsoninfo mini nameservice pgraph secure tas txtinfo watchdog
else
SUBDIRS := dot_draw dyn_gw dyn_gw_plain httpinfo jsoninfo mini nameservice pgraph secure txtinfo watchdog
endif
endif
endif

libs:
		@set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR);done

libs_clean clean_libs:
		-for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) clean;rm -f lib/$$dir/*.so lib/$$dir/*.dll;done
		-rm -f $(REGEX_OBJS)

libs_install install_libs:
		@set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) install;done

libs_uninstall uninstall_libs:
		@set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) uninstall;done
		rmdir -p --ignore-fail-on-non-empty $(LIBDIR)

#
# PLUGINS
#

arprefresh:
		@$(MAKECMD) -C lib/arprefresh

arprefresh_clean:
		@$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) clean

arprefresh_install:
		@$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) install

arprefresh_uninstall:
		@$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) uninstall

bmf:
		@$(MAKECMD) -C lib/bmf

bmf_clean:
		@$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) clean

bmf_install:
		@$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) install

bmf_uninstall:
		@$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) uninstall

dot_draw:
		@$(MAKECMD) -C lib/dot_draw

dot_draw_clean:
		@$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) clean

dot_draw_install:
		@$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) install

dot_draw_uninstall:
		@$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) uninstall

dyn_gw:
		@$(MAKECMD) -C lib/dyn_gw

dyn_gw_clean:
		@$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) clean

dyn_gw_install:
		@$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) install

dyn_gw_uninstall:
		@$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) uninstall

dyn_gw_plain:
		@$(MAKECMD) -C lib/dyn_gw_plain

dyn_gw_plain_clean:
		@$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) clean

dyn_gw_plain_install:
		@$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) install

dyn_gw_plain_uninstall:
		@$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) uninstall

httpinfo:
		@$(MAKECMD) -C lib/httpinfo

httpinfo_clean:
		@$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) clean

httpinfo_install:
		@$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) install

httpinfo_uninstall:
		@$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) uninstall

jsoninfo:
		@$(MAKECMD) -C lib/jsoninfo

jsoninfo_clean:
		@$(MAKECMD) -C lib/jsoninfo DESTDIR=$(DESTDIR) clean

jsoninfo_install:
		@$(MAKECMD) -C lib/jsoninfo DESTDIR=$(DESTDIR) install

jsoninfo_uninstall:
		@$(MAKECMD) -C lib/jsoninfo DESTDIR=$(DESTDIR) uninstall

mdns:
		@$(MAKECMD) -C lib/mdns

mdns_clean:
		@$(MAKECMD) -C lib/mdns DESTDIR=$(DESTDIR) clean

mdns_install:
		@$(MAKECMD) -C lib/mdns DESTDIR=$(DESTDIR) install

mdns_uninstall:
		@$(MAKECMD) -C lib/mdns DESTDIR=$(DESTDIR) uninstall

#
# no targets for mini: it's an example plugin
#

# nameserver uses regex, which was only recently added to Android.  On
# Android, $(REGEX_OBJS) will have all of the files needed, on all
# other platforms, it'll be empty and therefore ignored.
nameservice: $(REGEX_OBJS)
		@$(MAKECMD) -C lib/nameservice clean
		@$(MAKECMD) -C lib/nameservice

nameservice_clean:
		@$(MAKECMD) -C lib/nameservice DESTDIR=$(DESTDIR) clean

nameservice_install:
		@$(MAKECMD) -C lib/nameservice DESTDIR=$(DESTDIR) install

nameservice_uninstall:
		@$(MAKECMD) -C lib/nameservice DESTDIR=$(DESTDIR) uninstall

p2pd:
		@$(MAKECMD) -C lib/p2pd

p2pd_clean:
		@$(MAKECMD) -C lib/p2pd DESTDIR=$(DESTDIR) clean

p2pd_install:
		@$(MAKECMD) -C lib/p2pd DESTDIR=$(DESTDIR) install

p2pd_uninstall:
		@$(MAKECMD) -C lib/p2pd DESTDIR=$(DESTDIR) uninstall

pgraph:
		@$(MAKECMD) -C lib/pgraph

pgraph_clean:
		@$(MAKECMD) -C lib/pgraph DESTDIR=$(DESTDIR) clean

pgraph_install:
		@$(MAKECMD) -C lib/pgraph DESTDIR=$(DESTDIR) install

pgraph_uninstall:
		@$(MAKECMD) -C lib/pgraph DESTDIR=$(DESTDIR) uninstall

pud:
		@$(MAKECMD) -C lib/pud

pud_clean:
		@$(MAKECMD) -C lib/pud DESTDIR=$(DESTDIR) clean

pud_install:
		@$(MAKECMD) -C lib/pud DESTDIR=$(DESTDIR) install

pud_uninstall:
		@$(MAKECMD) -C lib/pud DESTDIR=$(DESTDIR) uninstall

quagga:
		@$(MAKECMD) -C lib/quagga

quagga_clean:
		@$(MAKECMD) -C lib/quagga DESTDIR=$(DESTDIR) clean

quagga_install:
		@$(MAKECMD) -C lib/quagga DESTDIR=$(DESTDIR) install

quagga_uninstall:
		@$(MAKECMD) -C lib/quagga DESTDIR=$(DESTDIR) uninstall

secure:
		@$(MAKECMD) -C lib/secure

secure_clean:
		@$(MAKECMD) -C lib/secure DESTDIR=$(DESTDIR) clean

secure_install:
		@$(MAKECMD) -C lib/secure DESTDIR=$(DESTDIR) install

secure_uninstall:
		@$(MAKECMD) -C lib/secure DESTDIR=$(DESTDIR) uninstall

sgwdynspeed:
		@$(MAKECMD) -C lib/sgwdynspeed

sgwdynspeed_clean:
		@$(MAKECMD) -C lib/sgwdynspeed DESTDIR=$(DESTDIR) clean

sgwdynspeed_install:
		@$(MAKECMD) -C lib/sgwdynspeed DESTDIR=$(DESTDIR) install

sgwdynspeed_uninstall:
		@$(MAKECMD) -C lib/sgwdynspeed DESTDIR=$(DESTDIR) uninstall

tas:
		@$(MAKECMD) -C lib/tas

tas_clean:
		@$(MAKECMD) -C lib/tas DESTDIR=$(DESTDIR) clean

tas_install:
		@$(MAKECMD) -C lib/tas DESTDIR=$(DESTDIR) install

tas_uninstall:
		@$(MAKECMD) -C lib/tas DESTDIR=$(DESTDIR) uninstall

txtinfo:
		@$(MAKECMD) -C lib/txtinfo

txtinfo_clean:
		@$(MAKECMD) -C lib/txtinfo DESTDIR=$(DESTDIR) clean

txtinfo_install:
		@$(MAKECMD) -C lib/txtinfo DESTDIR=$(DESTDIR) install

txtinfo_uninstall:
		@$(MAKECMD) -C lib/txtinfo DESTDIR=$(DESTDIR) uninstall

watchdog:
		@$(MAKECMD) -C lib/watchdog

watchdog_clean:
		@$(MAKECMD) -C lib/watchdog DESTDIR=$(DESTDIR) clean

watchdog_install:
		@$(MAKECMD) -C lib/watchdog DESTDIR=$(DESTDIR) install

watchdog_uninstall:
		@$(MAKECMD) -C lib/watchdog DESTDIR=$(DESTDIR) uninstall


build_all:	all switch libs

=== gui/linux-gtk/Makefile ===
CC ?=	gcc

CFLAGS += -Wall `pkg-config --cflags gtk+-2.0`
LDFLAGS +=
LIBS := `pkg-config --libs gtk+-2.0` -lm

OBJS=	src/main.o src/interface.o src/callbacks.o src/ipc.o \
	src/packet.o src/nodes.o src/routes.o

all:	olsrd-gui

olsrd-gui:	$(OBJS)
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)

clean:
	rm -f $(OBJS) olsrd-gui

install:
	mkdir -p ${DESTDIR}/usr/bin
	cp ./olsrd-gui ${DESTDIR}/usr/bin/

=== lib/jsoninfo/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_jsoninfo
PLUGIN_VER =	0.0

TOPDIR =	../..
include $(TOPDIR)/Makefile.inc

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		@echo "[LD] $@"
		@$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

uninstall:
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== lib/pud/Makefile ===
NMEALIB_PATH = nmealib
LIBRARY_PATH = wireformat
JAVA_PATH = wireformat-java
include $(LIBRARY_PATH)/Makefile.inc
NMEALIB_NAME := nmea
LIBRARY_NAME := $(PROJECT)


include Makefile.inc

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc


CFLAGS += -Werror -D_GNU_SOURCE


RESOURCESDIR = ./resources
NMEALIB_INC = $(NMEALIB_PATH)/include
NMEALIB_LIB = $(NMEALIB_PATH)/lib
LIBRARY_INC = $(LIBRARY_PATH)/include
LIBRARY_LIB = $(LIBRARY_PATH)/lib

CFLAGS += -I $(NMEALIB_INC) -I $(LIBRARY_INC)
LIBS += -L $(NMEALIB_LIB) -L $(LIBRARY_LIB) -l$(NMEALIB_NAME) -lm -l$(LIBRARY_NAME)

ifneq ($(OS),linux)

.PHONY: all default_target install clean

all: default_target

default_target install clean:
	@echo "*** $(PLUGIN_NAME) plugin only supported on Linux, sorry!"

else

GIT_SHA = $(shell git describe 2> /dev/null || echo "Unknown")
CFLAGS += -DGIT_SHA=\"$(GIT_SHA)\" -DPLUGIN_VER=\"$(PLUGIN_VER)\"

.PHONY: all default_target install uninstall clean doc doc-clean nmealib library java java-instal java-uninstall

all: default_target

default_target: nmealib library $(PLUGIN_FULLNAME)

# repeat from toplevel Makefile.inc, and adjust: we need the library includes
%.d: %.c
	@$(filter-out $(CCACHE),$(CC)) -M $(strip $(CPPFLAGS)) -I $(NMEALIB_INC) -I $(LIBRARY_INC) "$<" | sed -e '1s/\($(call quote,$(*F))\.o\)[ :]*/$(call quote,$(*D)/\1 $@: Makefile $(TOPDIR)$(if $(TOPDIR),/)Makefile.inc) /g' >"$@"

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
	@echo "[LD] $@"
	@$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install: all
	@$(MAKE) -C $(NMEALIB_PATH) DESTDIR=$(DESTDIR) install
	@$(MAKE) -C $(LIBRARY_PATH) DESTDIR=$(DESTDIR) install
	$(INSTALL_LIB)
	mkdir -p "$(ETCDIR)"
	cp "$(RESOURCESDIR)/olsrd.pud.position.conf" "$(ETCDIR)"
	$(STRIP) "$(LIBDIR)/$(PLUGIN_FULLNAME)"

uninstall:
	@$(MAKE) -C $(NMEALIB_PATH) DESTDIR=$(DESTDIR) uninstall
	@$(MAKE) -C $(LIBRARY_PATH) DESTDIR=$(DESTDIR) uninstall
	rm -f "$(LIBDIR)/lib$(PLUGIN_NAME).so" "$(LIBDIR)/$(PLUGIN_NAME)" "$(ETCDIR)/olsrd.pud.position.conf"
	$(UNINSTALL_LIB)
	rmdir -v -p --ignore-fail-on-non-empty "$(LIBDIR)" "$(ETCDIR)"

clean:
	@echo "[$@]"
	@rm -f $(OBJS) $(SRCS:%.c=%.d) "$(PLUGIN_FULLNAME)"
	@$(MAKE) -C doc clean
	@$(MAKE) -C $(NMEALIB_PATH) clean
	@$(MAKE) -C $(LIBRARY_PATH) clean
	@$(MAKE) -C $(JAVA_PATH) clean

doc:
	@$(MAKE) -C doc all
	@$(MAKE) -C $(NMEALIB_PATH) doc
	@$(MAKE) -C $(LIBRARY_PATH) doc
	@$(MAKE) -C $(JAVA_PATH) doc

doc-clean:
	@$(MAKE) -C doc clean
	@$(MAKE) -C $(NMEALIB_PATH) doc clean
	@$(MAKE) -C $(LIBRARY_PATH) doc clean
	@$(MAKE) -C $(JAVA_PATH) doc clean

nmealib:
	@$(MAKE) -C $(NMEALIB_PATH) all

library:
	@$(MAKE) -C $(LIBRARY_PATH) all

java:
	@$(MAKE) -C $(JAVA_PATH) all

java-install: java
	@$(MAKE) -C $(JAVA_PATH) DESTDIR=$(DESTDIR) install

java-uninstall:
	@$(MAKE) -C $(JAVA_PATH) DESTDIR=$(DESTDIR) uninstall

endif

=== lib/sgwdynspeed/Makefile ===
include Makefile.inc

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc


CFLAGS += -Werror

RESOURCESDIR = ./resources

ifneq ($(OS),linux)

.PHONY: all default_target install clean

all: default_target

default_target install clean:
	@echo "*** $(PLUGIN_NAME) plugin only supported on Linux, sorry!"

else

GIT_SHA = $(shell git describe 2> /dev/null || echo "Unknown")
CFLAGS += -DGIT_SHA=\"$(GIT_SHA)\" -DPLUGIN_VER=\"$(PLUGIN_VER)\"

.PHONY: all default_target install uninstall clean doc doc-clean java java-instal java-uninstall

all: default_target

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
	@echo "[LD] $@"
	@$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install: all
	$(INSTALL_LIB)
	mkdir -p "$(ETCDIR)"
	cp "$(RESOURCESDIR)/olsrd.sgw.speed.conf" "$(ETCDIR)"
	$(STRIP) "$(LIBDIR)/$(PLUGIN_FULLNAME)"

uninstall:
	rm -f "$(LIBDIR)/lib$(PLUGIN_NAME).so" "$(LIBDIR)/$(PLUGIN_NAME)" "$(ETCDIR)/olsrd.sgw.speed.conf"
	$(UNINSTALL_LIB)
	rmdir -v -p --ignore-fail-on-non-empty "$(LIBDIR)" "$(ETCDIR)"

clean:
	@echo "[$@]"
	@rm -f $(OBJS) $(SRCS:%.c=%.d) "$(PLUGIN_FULLNAME)"
	@$(MAKE) -C doc clean

doc:
	@$(MAKE) -C doc all

doc-clean:
	@$(MAKE) -C doc clean

endif

=== lib/tas/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2004, Andreas Tonnesen(andreto@olsr.org)
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
#
# * Redistributions of source code must retain the above copyright 
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright 
#   notice, this list of conditions and the following disclaimer in 
#   the documentation and/or other materials provided with the 
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its 
#   contributors may be used to endorse or promote products derived 
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_tas
PLUGIN_VER =	0.1

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

SRCS +=		$(wildcard src/lua/*.c)
HDRS +=		$(wildcard src/lua/*.h)

ifneq ($(OS),win32)
LIBS +=		-lm
endif

ifneq ($(OS),$(filter $(OS),linux android))

default_target install clean: 
	@echo "*** TAS Plugin only supported on Linux, sorry!"

else

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
		@echo "[LD] $@"
		@$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

# this is not nice but there is no nicer solution
src/lua/lapi.o src/lua/ltable.o:  CFLAGS += -Wno-cast-qual
src/lua/ldebug.o src/lua/ldo.o src/lua/lbaselib.o src/lua/ldblib.o src/lua/lvm.o src/lua/lapi.o: CFLAGS += -Wno-switch-default

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

uninstall:
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

endif

=== src/olsr_switch/Makefile ===
TOPDIR=../..
include $(TOPDIR)/Makefile.inc

ifeq ($(OS), win32)
BINNAME = olsr_switch.exe
OBJS += ../win32/compat.o
else
BINNAME = olsr_switch
endif

default_target:	$(TOPDIR)/$(BINNAME)

$(TOPDIR)/$(BINNAME):	$(OBJS)
	@echo "[LD] $@"
	@$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)

ohs_cmd.o: CFLAGS += -Wno-cast-qual -DNO_OLDNAMES

clean:
	rm -f *.[od]
	rm -f *~
	rm -f $(TOPDIR)/$(BINNAME)

=== lib/pud/doc/Makefile ===
include ../Makefile.inc

HTML_DIR = html
MAN_DIR = man
LATEX_DIR = latex
PDF_NAME = $(PLUGIN_NAME).pdf
DOX_FILE = doxygen.conf
TMP_DOX_FILE = $(DOX_FILE).temp

.PHONY: .gitignore all clean

.gitignore:
	@echo "[$@] doc"
	@echo "/$(HTML_DIR)/" > $@
	@echo "/$(MAN_DIR)/" >> $@
	@echo "/$(LATEX_DIR)/" >> $@
	@echo "/$(TMP_DOX_FILE)" >> $@
	@echo "/$(PDF_NAME)" >> $@

clean:
	@echo "[$@] doc"
	@rm -fr "$(TMP_DOX_FILE)" "$(HTML_DIR)" "$(LATEX_DIR)" "$(MAN_DIR)" "$(PDF_NAME)"

all: clean $(DOX_FILE)
	@echo "[$@] doc"
	@sed \
	  -e "s/__PLUGIN_VER__/$(PLUGIN_VER)/" \
	  -e "s/__LIBNAME__/$(PLUGIN_NAME)/" \
	  "$(DOX_FILE)" > "$(TMP_DOX_FILE)"
	@doxygen "$(TMP_DOX_FILE)"
	@rm "$(TMP_DOX_FILE)"
	@$(MAKE) -s -C $(LATEX_DIR) all > /dev/null 2>&1
	@mv "$(LATEX_DIR)/refman.pdf" "$(PDF_NAME)"
	@rm -fr "$(LATEX_DIR)"

=== lib/pud/nmealib/Makefile ===
include ../Makefile.inc
OLSRD_PLUGIN = false

TOPDIR = ../../..
include $(TOPDIR)/Makefile.inc


include Makefile.inc

#
# Settings
#

LIBNAME = libnmea.so

DESTDIR ?=

MACHINE=$(shell uname -m)
LIBDIR_INSTALL = usr/lib
INCLUDEDIR = usr/include

MODULES = context generate generator gmath info parse parser sentence time tok util
OBJ = $(MODULES:%=build/%.o)

LIBRARIES = -lm
INCLUDES = -I ./include


#
# Targets
#

all: default_target

default_target: all-before lib/$(LIBNAME)

remake: clean all

lib/$(LIBNAME): $(OBJ)
	@echo "[LD] $@"
	@$(CC) -shared -Wl,-soname=$(LIBNAME) -o "$@" $(LIBRARIES) $(OBJ)

build/%.o: src/%.c Makefile Makefile.inc
	@echo "[CC] $<"
	@$(CC) $(CFLAGS) $(INCLUDES) -c $< -o $@

samples: all
	@$(MAKE) -C samples all


#
# Phony Targets
#

.PHONY: all default_target all-before clean doc install install-headers uninstall uninstall-headers

all-before:
	@mkdir -p build lib

clean:
	@$(MAKE) -C doc clean
	@$(MAKE) -C samples clean
	rm -fr build lib

doc:
	$(MAKE) -C doc all

install: all
	@mkdir -v -p "$(DESTDIR)/$(LIBDIR_INSTALL)"
	cp "lib/$(LIBNAME)" "$(DESTDIR)/$(LIBDIR_INSTALL)/$(LIBNAME).$(VERSION)"
	$(STRIP) "$(DESTDIR)/$(LIBDIR_INSTALL)/$(LIBNAME).$(VERSION)"
	ldconfig -n "$(DESTDIR)/$(LIBDIR_INSTALL)"

install-headers: all
	@mkdir -v -p "$(DESTDIR)/$(INCLUDEDIR)"
	@rm -fr "$(DESTDIR)/$(INCLUDEDIR)/nmea"
	cp -r include/nmea "$(DESTDIR)/$(INCLUDEDIR)"

uninstall:
	rm -f "$(DESTDIR)/$(LIBDIR_INSTALL)/$(LIBNAME)" "$(DESTDIR)/$(LIBDIR_INSTALL)/$(LIBNAME).$(VERSION)"
	ldconfig -n "$(DESTDIR)/$(LIBDIR_INSTALL)"
	@rmdir -v -p --ignore-fail-on-non-empty "$(DESTDIR)/$(LIBDIR_INSTALL)"

uninstall-headers:
	rm -fr "$(DESTDIR)/$(INCLUDEDIR)/nmea"
	@rmdir -v -p --ignore-fail-on-non-empty "$(DESTDIR)/$(INCLUDEDIR)"

=== lib/pud/wireformat-java/Makefile ===
include ../wireformat/Makefile.inc
WIREFORMAT_PROJECT := $(PROJECT)

include Makefile.inc

include ../Makefile.inc
OLSRD_PLUGIN = false

TOPDIR = ../../..
include $(TOPDIR)/Makefile.inc

######################
#
# Settings
#
######################

ifeq ($(DEBUG),1)
DEBUGBOOLEAN = true
else
DEBUGBOOLEAN = false
endif

MACHINE=$(shell uname -m)
LIBDIR_INSTALL = usr/lib
ARCH=
ifeq ($(strip $(MACHINE)),x86_64)
  ARCH=.$(MACHINE)
endif


RESOURCES_DIR = resources

BUILD_DIR = build

INC_DIR_WIREFORMAT = ../wireformat/include
INC_DIR_WIREFORMAT_FULL = $(INC_DIR_WIREFORMAT)/$(WIREFORMAT_PROJECT)

INC_DIR_JVM = /usr/lib/jvm/java-1.6.0-openjdk$(ARCH)/include
INC_DIR_JVM_OS = $(INC_DIR_JVM)/$(OS)

LIBDIR_BUILD = lib

SRC_DIR_C = src/main/c

INCLUDES = -I "$(INC_DIR_WIREFORMAT)" -I "$(INC_DIR_JVM)" -I "$(INC_DIR_JVM_OS)"
LIBRARIES = -L ../wireformat/lib -l$(WIREFORMAT_PROJECT)

DESTDIR ?=
JAVA_DIR_INSTALL = usr/share/java/olsrd

BUILD_DIR_JNI = $(BUILD_DIR)/jni

JAVASRC = src/main/java
JAVAVERSIONSRC = 1.6
JAVAVERSIONDST = 1.6
JAVABOOTCLASSPATH = resources/ee.j2se/$(JAVAVERSIONSRC)/ee.j2se.jar
JAVA_PKG = org.olsr.plugin.pud
JAVA_PKG_DIR = $(subst .,/,$(JAVA_PKG))
JAVA_PKG_UNDER = $(subst .,_,$(JAVA_PKG))


ifneq ($(OS),linux)

.PHONY: all default_target install clean

all: default_target

default_target install clean:
	@echo "*** only supported on Linux"

else

GIT_SHA = $(shell git describe 2> /dev/null || echo "Unknown")

.PHONY: all default_target java prepare clean doc doc-clean install uninstall

#
# Targets
#

all: default_target

default_target: prepare $(LIBDIR_BUILD)/$(SONAME) java

.gitignore:
	@echo "[$@]"
	@echo "/$(BUILD_DIR)/" > $@
	@echo "/$(LIBDIR_BUILD)/" >> $@
	@echo "/build.xml" >> $@
	@echo "/$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_PositionUpdate.h" >> $@
	@echo "/$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_ClusterLeader.h" >> $@
	@echo "/$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_UplinkMessage.h" >> $@
	@echo "/$(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java" >> $@
	@$(MAKE) -C doc $@

$(LIBDIR_BUILD)/$(SONAME): $(BUILD_DIR)/$(JAVA_PKG_UNDER)_UplinkMessage.o \
                           $(BUILD_DIR)/$(JAVA_PKG_UNDER)_ClusterLeader.o \
                           $(BUILD_DIR)/$(JAVA_PKG_UNDER)_PositionUpdate.o
	@echo "[LD] $@"
	@$(CC) -shared -Wl,-soname=$(SONAME) $(LIBRARIES) -o "$@" \
      $(BUILD_DIR)/$(JAVA_PKG_UNDER)_UplinkMessage.o \
      $(BUILD_DIR)/$(JAVA_PKG_UNDER)_ClusterLeader.o \
      $(BUILD_DIR)/$(JAVA_PKG_UNDER)_PositionUpdate.o

# PositionUpdate
$(BUILD_DIR)/$(JAVA_PKG_UNDER)_PositionUpdate.o: $(SRC_DIR_C)/$(JAVA_PKG_UNDER)_PositionUpdate.c \
                                                 $(SRC_DIR_C)/$(JAVA_PKG_UNDER)_PositionUpdate.h \
                                                 $(INC_DIR_WIREFORMAT_FULL)/wireFormat.h \
                                                 $(INC_DIR_WIREFORMAT_FULL)/nodeIdConversion.h
	@echo "[CC] $<"
	@$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c -o "$@" "$<"

$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_PositionUpdate.h: $(BUILD_DIR_JNI)/$(JAVA_PKG_DIR)/PositionUpdate.class
	@echo "[JavaH] $<"
	@rm -f "$@"
	@javah -jni -classpath "$(BUILD_DIR_JNI)" -o "$@" "$(JAVA_PKG).PositionUpdate"

$(BUILD_DIR_JNI)/$(JAVA_PKG_DIR)/PositionUpdate.class: $(JAVASRC)/$(JAVA_PKG_DIR)/PositionUpdate.java \
                                                       $(JAVASRC)/$(JAVA_PKG_DIR)/LibraryLoader.java \
                                                       $(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java
	@echo "[JavaC] $<"
	@javac -bootclasspath $(JAVABOOTCLASSPATH) -classpath $(JAVASRC) -source 1.6 -target 1.6 -Xlint -d "$(BUILD_DIR_JNI)" "$<"

# ClusterLeader
$(BUILD_DIR)/$(JAVA_PKG_UNDER)_ClusterLeader.o: $(SRC_DIR_C)/$(JAVA_PKG_UNDER)_ClusterLeader.c \
                                                 $(SRC_DIR_C)/$(JAVA_PKG_UNDER)_ClusterLeader.h \
                                                 $(INC_DIR_WIREFORMAT_FULL)/wireFormat.h \
                                                 $(INC_DIR_WIREFORMAT_FULL)/nodeIdConversion.h
	@echo "[CC] $<"
	@$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c -o "$@" "$<"

$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_ClusterLeader.h: $(BUILD_DIR_JNI)/$(JAVA_PKG_DIR)/ClusterLeader.class
	@echo "[JavaH] $<"
	@rm -f "$@"
	@javah -jni -classpath "$(BUILD_DIR_JNI)" -o "$@" "$(JAVA_PKG).ClusterLeader"

$(BUILD_DIR_JNI)/$(JAVA_PKG_DIR)/ClusterLeader.class: $(JAVASRC)/$(JAVA_PKG_DIR)/ClusterLeader.java \
                                                      $(JAVASRC)/$(JAVA_PKG_DIR)/LibraryLoader.java \
                                                      $(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java
	@echo "[JavaC] $<"
	@javac -bootclasspath $(JAVABOOTCLASSPATH) -classpath $(JAVASRC) -source 1.6 -target 1.6 -Xlint -d "$(BUILD_DIR_JNI)" "$<"

# UplinkMessage
$(BUILD_DIR)/$(JAVA_PKG_UNDER)_UplinkMessage.o: $(SRC_DIR_C)/$(JAVA_PKG_UNDER)_UplinkMessage.c \
                                                 $(SRC_DIR_C)/$(JAVA_PKG_UNDER)_UplinkMessage.h \
                                                 $(INC_DIR_WIREFORMAT_FULL)/wireFormat.h \
                                                 $(INC_DIR_WIREFORMAT_FULL)/nodeIdConversion.h
	@echo "[CC] $<"
	@$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c -o "$@" "$<"

$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_UplinkMessage.h: $(BUILD_DIR_JNI)/$(JAVA_PKG_DIR)/UplinkMessage.class
	@echo "[JavaH] $<"
	@rm -f "$@"
	@javah -jni -classpath "$(BUILD_DIR_JNI)" -o "$@" "$(JAVA_PKG).UplinkMessage"

$(BUILD_DIR_JNI)/$(JAVA_PKG_DIR)/UplinkMessage.class: $(JAVASRC)/$(JAVA_PKG_DIR)/UplinkMessage.java \
                                                      $(JAVASRC)/$(JAVA_PKG_DIR)/LibraryLoader.java \
                                                      $(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java
	@echo "[JavaC] $<"
	@javac -bootclasspath $(JAVABOOTCLASSPATH) -classpath $(JAVASRC) -source 1.6 -target 1.6 -Xlint -d "$(BUILD_DIR_JNI)" "$<"


#
# java
#

java: prepare \
     build.xml \
     $(JAVASRC)/$(JAVA_PKG_DIR)/PositionUpdate.java \
     $(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java
	@ant -f build.xml release

build.xml: $(RESOURCES_DIR)/build.xml
	@echo "[generate] $@"
	@sed -r -e "s#PLUGIN_VER#$(PLUGIN_VER)#g" \
	        -e "s#PROJECT#$(PROJECT)#g" \
	        -e "s#BUILD_DIR#$(BUILD_DIR)#g" \
	        -e "s#LIBDIR_BUILD#$(LIBDIR_BUILD)#g" \
	        -e "s#JAVASRC#$(JAVASRC)#g" \
	        -e "s#JAVAVERSIONSRC#$(JAVAVERSIONSRC)#g" \
	        -e "s#JAVAVERSIONDST#$(JAVAVERSIONDST)#g" \
	        -e "s#DEBUG#$(DEBUGBOOLEAN)#g" \
	        "$<" > "$@"


#
# generate java classes
#

$(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java: \
      $(RESOURCES_DIR)/WireFormatConstants.java.h \
      $(BUILD_DIR_JNI)/c/library.h \
      $(BUILD_DIR_JNI)/c/wireFormat.h
	@echo "[generate] $@"
	@$(CPP) -I "$(BUILD_DIR_JNI)/c" -DPLUGIN_VER=\"$(PLUGIN_VER)\" -DGIT_SHA=\"$(GIT_SHA)\" "$<" | \
	  sed -r -e '/^[[:space:]]*#.*$$/ d' \
	         -e '/^[[:space:]]*$$/ d' \
	         > "$@"


#
# generate jni includes
#

$(BUILD_DIR_JNI)/c/library.h: Makefile.inc
	@echo "[generate] $@"
	@echo "#define PUD_WIRE_FORMAT_LIBRARYNAME \"$(PROJECT)\"" > "$@"

$(BUILD_DIR_JNI)/c/wireFormat.h: $(INC_DIR_WIREFORMAT_FULL)/wireFormat.h
	@echo "[generate] $@"
	@grep -E '^[[:space:]]*#define[[:space:]]+' "$<" > "$@"


#
# Phony Targets
#

prepare:
	@mkdir -p "$(BUILD_DIR)" \
	          "$(LIBDIR_BUILD)" \
	          "$(BUILD_DIR_JNI)/c"


clean: doc-clean
	@echo "[$@]"
	@rm -fr "$(BUILD_DIR)" "$(LIBDIR_BUILD)" \
	        build.xml \
	        "$(SRC_DIR_C)/$(JAVA_PKG_UNDER)_PositionUpdate.h" \
	        "$(JAVASRC)/$(JAVA_PKG_DIR)/WireFormatConstants.java"

doc: build.xml
	@$(MAKE) -C doc all
	@ant -f build.xml javadoc

doc-clean:
	@$(MAKE) -C doc clean

install: all
	mkdir -v -p "$(DESTDIR)/$(LIBDIR_INSTALL)"
	cp "$(LIBDIR_BUILD)/$(SONAME)" "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME).$(PLUGIN_VER)"
	$(STRIP) "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME).$(PLUGIN_VER)"
	ldconfig -n "$(DESTDIR)/$(LIBDIR_INSTALL)"
	mkdir -v -p "$(DESTDIR)/$(JAVA_DIR_INSTALL)"
	cp -t "$(DESTDIR)/$(JAVA_DIR_INSTALL)" \
      "$(LIBDIR_BUILD)/$(PROJECT).jar" \
      "$(LIBDIR_BUILD)/$(PROJECT)-src.zip" \
      "$(LIBDIR_BUILD)/$(PROJECT)-doc.zip"

uninstall:
	rm -f "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME)" \
	      "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME).$(PLUGIN_VER)"
	ldconfig -n "$(DESTDIR)/$(LIBDIR_INSTALL)"
	rmdir -v -p --ignore-fail-on-non-empty "$(DESTDIR)/$(LIBDIR_INSTALL)"
	rm -f "$(DESTDIR)/$(JAVA_DIR_INSTALL)/$(PROJECT).jar" \
          "$(DESTDIR)/$(JAVA_DIR_INSTALL)/$(PROJECT)-src.zip" \
          "$(DESTDIR)/$(JAVA_DIR_INSTALL)/$(PROJECT)-doc.zip"
	rmdir -v -p --ignore-fail-on-non-empty "$(DESTDIR)/$(JAVA_DIR_INSTALL)"

endif

=== lib/pud/wireformat/Makefile ===
include Makefile.inc

include ../Makefile.inc
OLSRD_PLUGIN = false

TOPDIR = ../../..
include $(TOPDIR)/Makefile.inc

######################
#
# Settings
#
######################

MACHINE=$(shell uname -m)
LIBDIR_INSTALL = usr/lib

BUILD_DIR = build

INC_DIR_BASE_C = include
INC_DIR_C = $(INC_DIR_BASE_C)/$(PROJECT)
INC_DIR_OLSRD = ../../../src

LIBDIR_BUILD = lib

MODULES = nodeIdConversion wireFormat

SRC_DIR_C = src
OBJECTS_C = $(MODULES:%=$(BUILD_DIR)/%.o)

INCLUDES = -I "$(INC_DIR_BASE_C)" -I "$(INC_DIR_OLSRD)"
LIBRARIES = -lm

DESTDIR ?=
INC_DIR_INSTALL = usr/$(INC_DIR_C)


ifneq ($(OS),linux)

.PHONY: all default_target install clean

all: default_target

default_target install clean:
	@echo "*** only supported on Linux"

else

.PHONY: all default_target prepare clean doc doc-clean install install-headers uninstall uninstall-headers

#
# Targets
#

all: default_target

default_target: prepare $(LIBDIR_BUILD)/$(SONAME)

$(LIBDIR_BUILD)/$(SONAME): $(OBJECTS_C)
	@echo "[LD] $@"
	@$(CC) -shared -Wl,-soname=$(SONAME) $(LIBRARIES) -o "$@" $(OBJECTS_C)

$(BUILD_DIR)/%.o: $(SRC_DIR_C)/%.c $(INC_DIR_C)/compiler.h
	@echo "[CC] $<"
	@$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c -o "$@" "$<"

.gitignore:
	@echo "[$@]"
	@echo "/$(BUILD_DIR)/" > $@
	@echo "/$(LIBDIR_BUILD)/" >> $@
	@$(MAKE) -C doc $@


#
# Phony Targets
#

prepare:
	@mkdir -p "$(BUILD_DIR)" "$(LIBDIR_BUILD)"

clean: doc-clean
	@echo "[$@]"
	@rm -fr "$(BUILD_DIR)" "$(LIBDIR_BUILD)" "$(SRC_DIR_C)/"*.d

doc:
	@$(MAKE) -C doc all

doc-clean:
	@$(MAKE) -C doc clean

install: all
	mkdir -v -p "$(DESTDIR)/$(LIBDIR_INSTALL)"
	cp "$(LIBDIR_BUILD)/$(SONAME)" "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME).$(PLUGIN_VER)"
	$(STRIP) "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME).$(PLUGIN_VER)"
	ldconfig -n "$(DESTDIR)/$(LIBDIR_INSTALL)"

install-headers:
	rm -fr "$(DESTDIR)/$(INC_DIR_INSTALL)"
	mkdir -v -p "$(DESTDIR)/$(INC_DIR_INSTALL)"
	cp -t "$(DESTDIR)/$(INC_DIR_INSTALL)" $(INC_DIR_C)/*.h

uninstall:
	rm -f "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME)" \
	      "$(DESTDIR)/$(LIBDIR_INSTALL)/$(SONAME).$(PLUGIN_VER)"
	ldconfig -n "$(DESTDIR)/$(LIBDIR_INSTALL)"
	rmdir -v -p --ignore-fail-on-non-empty \
	  "$(DESTDIR)/$(LIBDIR_INSTALL)"

uninstall-headers:
	rm -fr "$(DESTDIR)/$(INC_DIR_INSTALL)/"*.h
	rmdir -v -p --ignore-fail-on-non-empty \
	  "$(DESTDIR)/$(INC_DIR_INSTALL)"

endif

=== lib/pud/nmealib/doc/Makefile ===
include ../Makefile.inc

.PHONY: all clean

clean:
	rm -fr html latex man nmealib.pdf

all: clean nmea.doxygen
	@echo "Updating version..."
	@sed -r "s/^([[:space:]]*PROJECT_NUMBER[[:space:]]*=).*/\1 $(GITVERSION)/" nmea.doxygen > nmea.doxygen.temp
	@echo "Generating HTML and man pages..."
	@doxygen nmea.doxygen.temp
	@rm nmea.doxygen.temp
	@echo "Generating PDF..."
	@make -C latex -s > /dev/null 2>&1
	@mv latex/refman.pdf nmealib.pdf
	@rm -fr latex
	@echo "Done"

=== debian/changelog ===
olsrd (0.6.3-5) unstable; urgency=low

  * fixed build system so all hardening flags are applied
  * fixed some lintian warnings
  * make tas plugin build against Debian's lua rather than the lua sources
    that are included in the olsrd orig tarball

 -- Hans-Christoph Steiner <hans@eds.org>  Fri, 05 Oct 2012 17:38:02 -0400

olsrd (0.6.3-4) unstable; urgency=low

  * debian/rules: Drop OS=linux from the make call, fixing FTBFS on !linux,
    thanks to Evgeni Golov (Closes: #679761)

 -- Roland Stigge <stigge@antcom.de>  Fri, 06 Jul 2012 18:58:27 +0200

olsrd (0.6.3-3) unstable; urgency=low

  * update broken jsoninfo plugin with patches from upstream git
  * updated default config based on settings from funkfeuer and
    commotionwireless.net

 -- Hans-Christoph Steiner <hans@eds.org>  Sat, 30 Jun 2012 09:57:55 -0400

olsrd (0.6.3-2) unstable; urgency=low

  * Re-upload to unstable

 -- Roland Stigge <stigge@antcom.de>  Sun, 24 Jun 2012 18:00:24 +0200

olsrd (0.6.3-1) experimental; urgency=low

  * New upstream release
  * debian/control: Standards-Version: 3.9.3

 -- Roland Stigge <stigge@antcom.de>  Fri, 08 Jun 2012 12:30:36 +0200

=== debian/control ===
Source: olsrd
Section: net
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Uploaders: Hans-Christoph Steiner <hans@eds.org>
Build-Depends: debhelper (>= 9),
               bison,
               flex,
               pkg-config,
               libgtk2.0-dev,
               python-gtk2-dev,
               liblua50-dev
Standards-Version: 3.9.3
Homepage: http://olsr.org/
Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/olsrd/
Vcs-Browser: http://svn.debian.org/wsvn/collab-maint/deb-maint/olsrd/

Package: olsrd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: olsrd-plugins
Description: optimized link-state routing daemon (unik-olsrd)
 unik-olsrd is an implementation of the Optimized Link State Routing protocol 
 for Mobile Ad-Hoc networks(MANET). The protocol is described in RFC3626. It 
 is designed to be run as a standalone server process.
 .
 OLSR operates as a table driven, proactive protocol, i.e., it exchanges 
 topology information with other nodes of the network regularly. It is 
 developed to work independently from other protocols. Likewise, OLSR makes no
 assumptions about the underlying link-layer.

Package: olsrd-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, olsrd (= ${binary:Version})
Description: various plugins to enhance olsrd
 olsrd is an implementation of the Optimized Link State Routing protocol
 for Mobile Ad-Hoc networks(MANET)
 .
 The following plugins are available:
 .
  * httpinfo      - tiny webserver for information purposes 
  * dyn_gw        - dynamically announce uplinks
  * dot_draw      - generates output (over a TCP socket) in the dot format
  * secure        - secure OLSR routing with a shared key
  * nameservice   - announce hostnames and dns servers
  * bmf           - basic multicast forwarding
  * quagga        - import external routes from quagga
  * txtinfo       - display information about the OSLR node
 .
 The following plugins are also included, even though experimental and demo
 plugins:
 .
  * pgraph        - performance graph
  * watchdog      - detection of olsrd freeze
  * tas           - tiny application server
  * mini          - minimal example plugin (demo)
  * dyn_gw_plain  - dyn_gw without ping/libthread
  * arprefresh    - optimize kernel arp cache from olsr UDP sniffing
  * mdnsp         - multicast DNS via OLSR mesh network
  * p2pd          - distribute P2P Discovery messages

Package: olsrd-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, olsrd (= ${binary:Version})
Description: GTK GUI to control and get info about olsrd
 olsrd-gui is a GTK GUI for controlling and getting information from a running
 olsrd, a daemon for OLSR mesh networking.  It uses IPC to talk to olsrd, so
 /etc/olsrd/olsrd.conf must enable IPC connections for olsrd-gui to work.
 .
 OLSR operates as a table driven, proactive protocol, i.e., it exchanges 
 topology information with other nodes of the network regularly. It is 
 developed to work independently from other protocols. Likewise, OLSR makes no
 assumptions about the underlying link-layer.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build: 
	$(MAKE) DEBUG=0 build_all
	$(MAKE) -C gui/linux-gtk
	$(MAKE) -C src/olsr_switch

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) distclean

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/olsrd install STRIP=: 
	$(MAKE) DESTDIR=$(CURDIR)/debian/olsrd-plugins libs_install STRIP=:
	$(MAKE) -C gui/linux-gtk DESTDIR=$(CURDIR)/debian/olsrd-gui install
	install -d $(CURDIR)/debian/olsrd/usr/sbin/
	install -p -m0755 files/olsrd-adhoc-setup $(CURDIR)/debian/olsrd/usr/sbin/
	install -d $(CURDIR)/debian/olsrd/usr/bin/
	install -p -m0755 olsr_switch $(CURDIR)/debian/olsrd/usr/bin/
	install -d $(CURDIR)/debian/olsrd/usr/share/man/man8
	install -p -m0644 files/olsr_switch.8.gz \
		$(CURDIR)/debian/olsrd/usr/share/man/man8
	install -d $(CURDIR)/debian/olsrd/usr/share/doc/olsrd/examples
	install -p -m0644 files/olsrd.conf.[a-z]* \
		$(CURDIR)/debian/olsrd.conf.funkfeuer \
		$(CURDIR)/debian/olsrd/usr/share/doc/olsrd/examples
	install -d $(CURDIR)/debian/olsrd-gui/usr/share/doc/olsrd-gui/
	install -p -m0644 gui/linux-gtk/CHANGELOG \
		$(CURDIR)/debian/olsrd-gui/usr/share/doc/olsrd-gui/changelog
	gzip -9 $(CURDIR)/debian/olsrd-gui/usr/share/doc/olsrd-gui/changelog
	# provide better default config
	install -p -m0644 $(CURDIR)/debian/olsrd.conf \
		$(CURDIR)/debian/olsrd/etc/olsrd/olsrd.conf
	install -p -m0644 $(CURDIR)/debian/olsrd-default \
		$(CURDIR)/debian/olsrd/etc/default/olsrd

override_dh_compress:
	# compress, but don't compress README_NAMESERVICE, for consistency reasons
	dh_compress -XREADME_NAMESERVICE -XREADME_BMF
